library curried;

class Curried {

  /**
   * Curries a binary function
   */
  static Function curry2(dynamic fn(dynamic, dynamic)) =>
    (a) => (b) => fn(a, b);

  /**
   * Curries a 3-ary function
   */
  static Function curry3(dynamic fn(dynamic, dynamic, dynamic)) =>
    (a) => (b) => (c) => fn(a, b, c);

  /**
   * Curries a 4-ary function
   */
  static Function curry4(dynamic fn(dynamic, dynamic, dynamic, dynamic)) =>
    (a) => (b) => (c) => (d) => fn(a, b, c, d);

  /**
   * Curries a 5-ary function
   */
  static Function curry5(dynamic fn(dynamic, dynamic, dynamic, dynamic, dynamic)) =>
    (a) => (b) => (c) => (d) => (e) => fn(a, b, c, d, e);

  /**
   * Curries a 6-ary function
   */
  static Function curry6(dynamic fn(dynamic, dynamic, dynamic, dynamic, dynamic, dynamic)) =>
    (a) => (b) => (c) => (d) => (e) => (f) => fn(a, b, c, d, e, f);

  /**
   * Curries a 7-ary function
   */
  static Function curry7(dynamic fn(dynamic, dynamic, dynamic, dynamic, dynamic, dynamic, dynamic)) =>
    (a) => (b) => (c) => (d) => (e) => (f) => (g) => fn(a, b, c, d, e, f, g);

  /**
   * Curries a 8-ary function
   */
  static Function curry8(dynamic fn(dynamic, dynamic, dynamic, dynamic, dynamic, dynamic, dynamic, dynamic)) =>
    (a) => (b) => (c) => (d) => (e) => (f) => (g) => (h) => fn(a, b, c, d, e, f, g, h);

  /**
   * Curries a 9-ary function
   */
  static Function curry9(dynamic fn(dynamic, dynamic, dynamic, dynamic, dynamic, dynamic, dynamic, dynamic, dynamic)) =>
    (a) => (b) => (c) => (d) => (e) => (f) => (g) => (h) => (i) => fn(a, b, c, d, e, f, g, h, i);

}